// Copyright 2022 Christian Ulrich
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// usage: ./part2 < input

pub mod common;

use common::{Group, Rucksacks};

fn main() -> Result<(), &'static str> {
    let rucksacks = Rucksacks {};
    let mut result = 0;
    let mut group_rucksacks = vec![];
    for rucksack in rucksacks {
        group_rucksacks.push(rucksack?);
        if group_rucksacks.len() == 3 {
            let group = Group::new(&group_rucksacks);
            result += group.badge()?.priority();
            group_rucksacks.clear();
        }
    }
    println!("{result}");
    Ok(())
}
