// Copyright 2022 Christian Ulrich
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// usage: ./part1 < input

pub mod common;

use common::{Moves, Stacks};

fn main() -> Result<(), &'static str> {
    let mut stacks = Stacks::from_stdin()?;
    for op in Moves::from_stdin() {
        stacks.move_items(op?)?;
    }
    let result: Result<String, _> = stacks
        .map(|s| s.last().cloned().ok_or("at least one stack is empty"))
        .collect();
    println!("{}", result?);
    Ok(())
}
