// Copyright 2022 Christian Ulrich
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// usage: ./part2 < input

pub mod common;

use common::Processor;

fn main() -> Result<(), &'static str> {
    let mut processor = Processor::new();
    let mut line = String::with_capacity(40);
    for (count, cycle) in processor.cycles().enumerate() {
        let x_during = cycle?.x_during;
        let sprite = x_during - 1..=x_during + 1;
        match count % 40 {
            pos if { sprite.contains(&(pos as i64)) } => line.push('#'),
            _ => line.push('.'),
        }
        if line.len() == 40 {
            println!("{line}");
            line.clear();
        }
    }
    Ok(())
}
