// Copyright 2022 Christian Ulrich
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// usage: ./part1 < input

pub mod common;

use common::{Game, Monkey};

fn main() -> Result<(), &'static str> {
    let game = Game::from_stdin(1)?;
    let last_round = game.take(10000).last().unwrap();
    let mut item_counts: Vec<_> = last_round?
        .monkeys()
        .iter()
        .map(Monkey::item_count)
        .collect();
    item_counts.sort();
    item_counts.reverse();
    println!("{}", item_counts[0] * item_counts[1]);
    Ok(())
}
